var five = require("../lib/johnny-five"),
    board = new five.Board(),
    fs = require('fs'),
    output = "eg/accel.json";


board.on("ready", function() {
  var collection = [];

  var accel = new five.Accelerometer({
    pins: [ "I0", "I1" ],
    freq: 100
  });

  accel.on("acceleration", function() {
    if (collection.length < 25) {
      collection.push({
        time: new Date(),
        raw: {
          x: this.raw.x,
          y: this.raw.y
        }
      });
      console.log(collection[collection.length - 1]);
    } else {
      fs.writeFile(output, JSON.stringify(collection, null, 2), function() {
        console.log("JSON saved");
        process.exit();
      });
    }
  });
});
