var five = require("../lib/johnny-five"),
    board, lcd;

board = new five.Board();

board.on("ready", function() {

  lcd = new five.LCD({
    // LCD pin name  RS  EN  DB4 DB5 DB6 DB7
    // Arduino pin # 7    8   9   10  11  12
    pins: [ 7, 8, 9, 10, 11, 12 ],

    // Options:
    // bitMode: 4 or 8, defaults to 4
    // lines: number of lines, defaults to 2
    // dots: matrix dimensions, defaults to "5x8"
  });

  lcd.on("ready", function() {
    // Creates a heart, accessible by string name/
    // Characters created with string names can
    // also be printed in-line,
    // eg. "I :heart: johnny-five"
    lcd.createChar( "heart",
      [ 0x00, 0x0a, 0x1f, 0x1f, 0x0e, 0x04, 0x00, 0x00 ]
    );

    lcd.createChar( 0x02,
      [ 0x0, 0xe, 0x11, 0x11, 0x11, 0xe, 0x0 ]
    );

    // lcd.createChar( "circle",
    //   [ 0x0, 0xe, 0x11, 0x11, 0x11, 0xe, 0x0 ]
    // );

    // Line 1: Hi rmurphey & hgstrp!
    lcd.clear().print("rmurphey, hgstrp");
    lcd.cursor(1, 0);


    // Line 2: I <3 johnny-five
    lcd.print("I :heart: johnny-five");

    setTimeout(function() {
      lcd.clear().print("A circle: ").write(2);
    }, 1500);
  });

  this.repl.inject({
    lcd: lcd
  });

});


// @markdown
// [16 x 2 LCD White on Blue](http://www.hacktronics.com/LCDs/16-x-2-LCD-White-on-Blue/flypage.tpl.html)
// [20 x 4 LCD White on Blue](http://www.hacktronics.com/LCDs/20-x-4-LCD-White-on-Blue/flypage.tpl.html)
// @markdown
