var five = require("../lib/johnny-five.js"),
    keypress = require("keypress"),
    board = new five.Board();


board.on("ready", function() {
  var speed, commands, servos;

  speed = 1;
  commands = null;
  servos = {
    right: new five.Servo({
      pin: 10,
      type: "continuous"
    }),
    left: new five.Servo({
      pin: 11,
      type: "continuous"
    })
  };

  this.repl.inject({
    servos: servos
  });

  function controller( ch, key ) {
    if ( key ) {
      if ( key.name === "space" ) {
        servos.right.stop();
        servos.left.stop();
      }
      if ( key.name === "up" ) {
        servos.right.ccw(speed);
        servos.left.cw(speed);
      }
      if ( key.name === "down" ) {
        servos.right.cw(speed);
        servos.left.ccw(speed);
      }
      if ( key.name === "right" ) {
        servos.right.cw(0.25);
        servos.left.cw(0.25);
      }
      if ( key.name === "left" ) {
        servos.right.ccw(0.25);
        servos.left.ccw(0.25);
      }

      commands = [].slice.call(arguments);
    } else {
      if ( ch >= 1 && ch <= 9 ) {
        speed = five.Fn.scale( ch, 1, 9, 0, 1 );
        controller.apply(null, commands);
      }
    }
  }


  keypress(process.stdin);

  process.stdin.on("keypress", controller);
  process.stdin.setRawMode(true);
  process.stdin.resume();
});
